package se.paxport.yggejonssoncrazysnake;

/**
 * @author Joel Jonsson
 */
public class CircularMyPosQueue {
    private MyPos[] q;

    private int head, tail;

    public CircularMyPosQueue(int maxSize) {
        q = new MyPos[maxSize];
        clear();
    }

    public void add(MyPos value) {
        q[tail++] = value;
        if (tail == head) {
            throw new IllegalStateException("Queue full");
        }
        if (tail == q.length) {
            tail = 0;
        }
    }

    public MyPos remove() {
        MyPos value = q[head++];
        if (head == q.length) {
            head = 0;
        }
        return value;
    }

    public boolean isEmpty() {
        return head == tail;
    }

    public void clear() {
        head = tail = 0;
    }

    public MyPos peek() {
        return q[head];
    }
}

