package se.paxport.yggejonssoncrazysnake;

import java.util.Arrays;
import java.util.List;

import se.citerus.crazysnake.HeatState;

/**
 * @author Joel Jonsson
 */
public class Follower extends NewPaxport2 {

    private int manhattan(MyPos p1, MyPos p2) {
        return Math.abs(p1.x - p2.x) + Math.abs(p1.y - p2.y);
    }

    @Override
    List<MyPos> getInterestingPositionsAndFillFrom(HeatState state) {
        List<MyPos> poss = super.getInterestingPositionsAndFillFrom(state);
        if (poss.isEmpty()) {
            return poss;
        }
        MyPos oppHead = MyPos.positionOf(getOpponent(state).getHeadPosition());
        MyPos nearest = poss.get(0);
        for (MyPos pos : poss) {
            if (manhattan(pos, oppHead) < manhattan(nearest, oppHead)) {
                nearest = pos;
            }
        }
        return Arrays.asList(nearest);
    }

    @Override
    public String getName() {
        return "Follower";
    }
}
